/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.FloatingLicenseTypeCombo");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("net.jazz.ajax.core.internal.util");

dojo.require("com.ibm.team.repository.web.client.internal.licensing");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

var LIC_P = com.ibm.team.repository.web.client.internal.licensing;
var getLicenseInfo = LIC_P.getLicenseInfo;
var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.FloatingLicenseTypeCombo", [dijit._Widget, dijit._Templated], {
		
	templateString: "<span class='com-ibm-team-repository-admin-floatingLicenseTypeCombo' dojoAttachPoint='licenseSelectionDiv'></span>",

	postCreate: function() {
		this._fetchAndDisplayTypeSelect();
	}, 
	
	_fetchAndDisplayTypeSelect: function () {
		//getWorkbench().showMessage(this.messages.loadingLicenseInfo);
		var self = this;
		var o = {
			s: function(licenseInfo) {
				//getWorkbench().hideMessageArea();
				self._displayCalTypesCombo(licenseInfo);
			},
			f: function(err) {
				if (self.onError) {
					self.onError(errorObj);
				}
			}
		}
		getLicenseInfo(new SRH(o, "s", "f"));
	},
	
	_displayCalTypesCombo: function(info) {
		this.floatingLicenses = info.floatingLicenseTypes || [];
		if (info.floatingLicenseTypes && info.floatingLicenseTypes.length > 0) {
			if (!this.licenseId) {
				this.licenseId = info.floatingLicenseTypes[0].id;
			}
			
			dojox.data.dom.removeChildren(this.licenseSelectionDiv);
			
			var self = this;
			var licenseSelect = document.createElement("select");
			var selectedIndex = null;
			var pos = 0;
			
			dojo.forEach(info.floatingLicenseTypes, function(cal) {
				var option = document.createElement("option");
				option.setAttribute("value", cal.id);
				option.innerHTML = cal.productName + " - " + cal.name;
				licenseSelect.appendChild(option);
				
				if (cal.id === self.licenseId) {
					selectedIndex = pos;
				}
				
				pos++;
			});	
			
			if (selectedIndex) {
				licenseSelect.selectedIndex = selectedIndex;
			}
			
			var handler = {
				changed: function() {
					self.licenseId = licenseSelect.value;
					if (self.onChange) 
						self.onChange(self.licenseId, self.getLicenseById(self.licenseId));
				}
			}
			dojo.connect(licenseSelect,"onchange",handler,"changed");
			this.licenseSelectionDiv.appendChild(licenseSelect);
			
			if (this.onLoad) 
				this.onLoad(this.licenseId, this.getLicenseById(this.licenseId));
		} else {
			if (this.onLoad) 
				this.onLoad(null);
		}
	}, 
	
	getLicenseById: function (calId){
		var result = null;
		if (!this.floatingLicenses) return result;
		
		dojo.forEach(this.floatingLicenses, function(cal) {
			if (cal.id === calId) {
				result = cal;
			}
		});
		return result;
	}

});

})();
