/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper");
    
    dojo.require("dojo.date");
    dojo.require("dojo.date.locale");
    dojo.require("dojo.date.stamp");
    dojo.require("dojo.number");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojox.data.dom");
    
    dojo.require("jazz.ui.HoverPopup");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
    
    dojo.require("com.ibm.team.repository.web.client.internal.licensing");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.repository.web.ui.internal.Util");
    dojo.require("dojo.i18n");
    
    dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseEditorMessages");

    
    //
    // Aliases
    //
 
    var HoverPopup = jazz.ui.HoverPopup;
    var removeChildren = dojox.data.dom.removeChildren;
    var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
   	var messages;
    //
    // Widget definition
    //
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper", [dijit._Widget, dijit._Templated], {
    
        //
        // Class properties
        //
        

        //
        // Widget lifecycle methods
        //
        constructor: function(){
            this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseEditorMessages");
        },
		     
        postCreate: function(){
			return;
        },
		
		_getInfopopLink: function(label, info, className){
            var hoverLink = document.createElement("a");
            hoverLink.href = "#";
            hoverLink.onclick = function(){
                return false;
            };
            hoverLink.innerHTML = label;
            if (className) {
                hoverLink.className = className;
            }
            else {
                hoverLink.className = "infopop";
            }
            var tooltip = new HoverPopup({
                around: hoverLink,
                html: info,
                openDelay: 300,
                orientation: "R"
            }, document.createElement("span"));
            
            return hoverLink;
        },
        
        _setInfopop: function(headerCell, label, info, className){
            removeChildren(headerCell);
            var hoverLink = this._getInfopopLink(label, info, className);
            headerCell.appendChild(hoverLink);
        },
        
        _setInfopopHeading: function(headerCell, labelKey, infoKey){
            this._setInfopop(headerCell, this.messages[labelKey], this.messages[infoKey], "infopop infopop-faded");
        },
		
		_setPurchasesOrTrialTableHeader: function(headerCell){
            var isTrial = this.licenseInfo.serverLicense.expirationTime ? true : false;
            var labelKey = isTrial ? "trialHeader" : "purchasedHeader";
            var infoKey = isTrial ? "trialHeaderInfo" : "purchasedHeaderInfo";
            this._setInfopopHeading(headerCell, labelKey, infoKey);
        }
    });

    
})();
